/********************************************************************************
*  ProjektTemplate für AVR ATmega128 mit Post-Build regel für avrdude.          *
*                                                                               *
*  Einstellungen für avrdude können über "Project/Build Options..."             *
*  geändert werden.                                                             *
*                                                                               *
*  #define F_CPU wird direkt an den compiler übergeben und muss nicht           *
*  neu definiert werden.                                                        *
*                                                                               *
*  Codeoptimierung ist eingeschaltet und kann über "Project/Build Options..."   *
*  geändert werden.                                                             *
*                                                                               *
*  Erstellt am 27.02.09 von Lambertz Peter                                      *
*                                                                               *
********************************************************************************/
#include <avr/io.h>
#include "lcd.h"
#include <stdio.h>
#include <util/delay.h>
#include <stdlib.h>

/*******************************************************************************
Funktion zum entprellen der Taster.
Aufruf mit z.b.
 if (taster(&PINA, PA0)==1)
    {
        //code
    }
*******************************************************************************/

int taster(volatile uint8_t *port, uint8_t pin)
{
    if ( ! (*port & (1 << pin)) )  //überprüfe ob taster gedrückt
    {
        _delay_ms(10);              //2ms warten

        if ( *port & (1 << pin) )  //prüfen ob taster immernoch gedrückt
        {

            _delay_ms(10);          //2ms warten

            return 1;              //falls taster noch gedrückt liefert eine 1 zurück
        }
    }
    return 0;                      //falls taster nichtmehr gedrückt liefert eine 0 zurück
}


int main ()
{

    /*******************************************************************************
    LCD_init(); initialiesiert das display ohne zusätzlichen befehl zum einschalten.
    stdout = &lcd_str: Leitet die Standartausgabe auf das LCD um.
    *******************************************************************************/
    LCD_init();
    stdout = &lcd_str;
    /*************ab hier initialisierung abgeschlossen und Programmbeginn*********/

    DDRA |= (1<<PINA1);
    DDRA &= ~(1<<PINA0);
    PORTA |= ((1<<PINA0)|(1<<PINA1));

    printf("Reaktionstest");

    while (1)
    {
        int count=0;
        _delay_ms((rand() %8 + 3)*1000);
        PORTA &= ~(1<<PINA1);

        do
        {
            _delay_ms(1);
            count++;


        }
        while (!taster(&PINA, PA0));
        PORTA |= (1<<PINA1);
        LCD_instruction(LCD_CLR); //Display löschen
        printf(" Zeit: %i ms",count);
        LCD_setpos(2,0); // cursor auf zeile 2, zeichen 0.

        if (count<240)
        {
            printf("Gut gemacht");
        }
        else
        {
            printf("Nicht so gut");
        }
        _delay_ms(5000);

        LCD_instruction(LCD_CLR); //Display löschen

int i=5;
for(i;i>=1;i--){
    printf("in 5sec restart");
    LCD_setpos(2,7);
    printf("%i",i);
    _delay_ms(1000);
    LCD_instruction(LCD_CLR); //Display löschen
    }

/*
        printf(" in 5sec restart");

        _delay_ms(2000);
        LCD_setpos(2,0); // cursor auf zeile 2, zeichen 0.
        printf(" 3");
        _delay_ms(1000);
        LCD_instruction(LCD_CLR); //Display löschen
        _delay_ms(50);
        LCD_setpos(2,0); // cursor auf zeile 2, zeichen 0.

        printf(" 2");

        _delay_ms(1000);
        LCD_instruction(LCD_CLR); //Display löschen
        _delay_ms(50);
        LCD_setpos(2,0); // cursor auf zeile 2, zeichen 0.
        printf(" 1");

        _delay_ms(1000);
        LCD_instruction(LCD_CLR); //Display löschen
*/
    }


}
